
-- Minimap button
ABicon = LibStub("LibDBIcon-1.0")

ABbunnyLDB = LibStub("LibDataBroker-1.1"):NewDataObject("ProfilesActionBarsMENU", {
	type = "launcher",
	icon = "Interface\\ICONS\\spell_nature_bloodlust",
	label = "Profiles: Action Bars",
	OnClick = function(self, button)
		if UnitAffectingCombat("player") then
			DEFAULT_CHAT_FRAME:AddMessage("Profiles: Action bars - Combat lockdown restriction. Leave combat and try again.")
		end
		
		if button == "RightButton" or button == "LeftButton" then
			PAB:OpenMinimapMenu()
		end
		
	end,
	OnTooltipShow = function(tooltip)
		tooltip:AddLine("Profiles");
	end,
	
})

-- Configuration menu. Minimap
function PAB:OpenMinimapMenu(window)
	
	if not self.profilesmenu then
		self.profilesmenu = CreateFrame("Frame", "ProfilesMenu")
	end
	
	local profilesmenu = self.profilesmenu
	profilesmenu.displayMode = "MENU"
	local info = {}
	profilesmenu.initialize = function(self, level)
		if not level then return end
		wipe(info)
		if level == 1 then

			-- blank separator
			wipe(info)
			info.disabled = 1
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			
			---------------
			wipe(info)
			info.notCheckable = 1
			info.isNotRadio = true
			info.text = "-- New profile --"
			
			info.func = function()
			
				local AceGUI = LibStub("AceGUI-3.0")
				local frame = AceGUI:Create("Frame")
				frame:SetTitle("Create a new profile")
				frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
				frame:SetLayout("Flow")
				frame:SetHeight(150)
				frame:SetWidth(220)

				local editbox = AceGUI:Create("EditBox")
				editbox:SetFocus(editbox)
				editbox:SetLabel("Profile name:")
				editbox:SetCallback("OnTextChanged", function(widget, event, text) textStore = text end)
				editbox:SetCallback("OnEnterPressed", function(widget, event, text) textStore = text PAB:PreSaveABProfile(textStore) AceGUI:Release(frame) end)
				editbox:SetWidth(200)
				editbox:DisableButton(true)
				frame:AddChild(editbox)

				local button = AceGUI:Create("Button")
				button:SetText("Save profile")
				button:SetCallback("OnClick", function() PAB:PreSaveABProfile(textStore) end)
				frame:AddChild(button)
					
			end
			
			UIDropDownMenu_AddButton(info, level)
			
			---------------
			wipe(info)
			info.notCheckable = 1
			info.isNotRadio = true
			info.text = "-- Save config to current profile --"
			
			info.func = function() 
					PAB:PreSaveABProfile(PABdb:GetCurrentProfile())
			end
			
			UIDropDownMenu_AddButton(info, level)
			
			
			-- blank separator
			wipe(info)
			info.disabled = 1
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			-- Title
			info.isTitle = 1
			info.text =  UnitName("player").." Specific Profiles"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			-- Iterate available profiles
			for i,v in orderedPairs(PAB:ListProfiles(1)) do
				wipe(info)
				
				info.hasArrow = 1
				info.value = win
				info.text = i
				info.isNotRadio = true
				info.func = function() 
					PAB:PreLoadABProfile(UIDROPDOWNMENU_MENU_VALUE)
				end
				
				
				
				info.checked = function() 
					
					if i == PABdb.char.Active_profile then
						return true
					end
				end
				
				UIDropDownMenu_AddButton(info, level)
			end
			
			-- blank separator
			wipe(info)
			info.disabled = 1
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			-- Title
			info.isTitle = 1
			info.text = "General Profiles"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
		
			-- General profiles
			for i,v in orderedPairs(PAB:ListProfiles("silent","globaldb")) do
				wipe(info)
				
				info.hasArrow = 1
				info.value = win
				info.text = i
				info.isNotRadio = true
				info.func = function() 
					PAB:PreLoadABProfile(UIDROPDOWNMENU_MENU_VALUE)
				end
				
				
				
				info.checked = function() 
					
					if i == PABdb.char.Active_profile then
						return true
					end
				end
				
				UIDropDownMenu_AddButton(info, level)
			end
			
			-- blank separator
			wipe(info)
			info.disabled = 1
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			
			------------
			wipe(info)
			info.isNotRadio = true
			info.text = "Mute status messages"
			
			info.func = function() 
					if PROFILES_TYST then
						PROFILES_TYST = nil
						PABdb.char.PROFILES_TYST = nil
						DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFProfiles: All status messages are now unmuted.")
					else
						PROFILES_TYST = true
						PABdb.char.PROFILES_TYST = true
						DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFProfiles: All status messages are now muted.")
					end
			end
			
			info.checked = function() 
				return PROFILES_TYST
			end
			UIDropDownMenu_AddButton(info, level)
			
			
			-- blank separator
			wipe(info)
			info.disabled = 1
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			
	
			
			-------------------
	        wipe(info)
			if PAB then info.text         = "|cff00ff00Action bars - Enabled"
			else info.text                = "|cffff0000Action bars - Disabled" end
	        info.disabled = 1
	        info.notCheckable = 1
			
			if PAB and PAB.tests then
				wipe(info)
			
				info.text         = "|cff00ff00Action bars - Run tests"
				info.isNotRadio = true
				info.notCheckable = 1
				info.value = win
				info.func = function() wowUnit:StartTests(PAB) end
			end
	        UIDropDownMenu_AddButton(info, level)
			
			-------------------
			
	        wipe(info)
			if KPS then info.text         = "|cff00ff00Keybinds - Enabled"
			else info.text                = "|cffff0000Keybinds - Disabled" end
	        info.disabled = 1
	        info.notCheckable = 1
			
			if KPS and KPS.tests then
				wipe(info)
			
				info.text         = "|cff00ff00Keybinds - Run tests"
				info.isNotRadio = true
				info.notCheckable = 1
				info.value = win
				info.func = function() wowUnit:StartTests(KPS) end
			end
	        UIDropDownMenu_AddButton(info, level)
			
			-------------------
	        wipe(info)
			if MPS then info.text         = "|cff00ff00Macros - Enabled"
			else info.text                = "|cffff0000Macros - Disabled" end
	        info.disabled = 1
	        info.notCheckable = 1
			
			if MPS and MPS.tests then
				wipe(info)
			
				info.text         = "|cff00ff00Macros - Run tests"
				info.isNotRadio = true
				info.notCheckable = 1
				info.value = win
				info.func = function() wowUnit:StartTests(MPS) end
			end
	        UIDropDownMenu_AddButton(info, level)
			
			-------------------
			
	        wipe(info)
			if RPS then info.text         = "|cff00ff00Recount - Enabled"
			else info.text                = "|cffff0000Recount - Disabled" end
	        info.disabled = 1
	        info.notCheckable = 1
			
			if RPS and RPS.tests then
				wipe(info)
			
				info.text         = "|cff00ff00Run - Run tests"
				info.isNotRadio = true
				info.notCheckable = 1
				info.value = win
				info.func = function() wowUnit:StartTests(RPS) end
			end
	        UIDropDownMenu_AddButton(info, level)
			
			
			-- blank separator
			wipe(info)
			info.disabled = 1
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			
			-- Close menu item
	        wipe(info)
	        info.text         = CLOSE
	        info.func         = function() CloseDropDownMenus() end
	        info.checked      = nil
	        info.notCheckable = 1
	        UIDropDownMenu_AddButton(info, level)
		elseif level == 2 then

			-- Chosen profile
			local profile_name = UIDROPDOWNMENU_MENU_VALUE
			
			-- Title
			info.isTitle = 1
			info.text = profile_name
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			
			wipe(info)
			info.text = "Activate"
			info.func = function() 
				PAB:PreLoadABProfile(profile_name)
			end
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			
			-- Comming soon(tm)
			-- wipe(info)
			-- info.text = "Rename"
			-- info.func = function() 
				-- DEFAULT_CHAT_FRAME:AddMessage("Profiles: All status messages are now muted.")
			-- end
			-- info.notCheckable = 1
			-- UIDropDownMenu_AddButton(info, level)
			
			-- Comming soon(tm)
--			wipe(info)
--			info.text = "Copy to general profiles"
--			info.func = function()
--				PAB:Echo("Exported: '"..profile_name.."'")
--				PAB:PreExport(profile_name)
--			end
--			info.notCheckable = 1
--			UIDropDownMenu_AddButton(info, level)
			
			-- blank separator
			wipe(info)
			info.disabled = 1
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			wipe(info)
			info.text = "Delete"
			info.func = function()
				PAB:PreDeleteProfile(profile_name)
			end
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			
		end
	end
	
	local x,y = GetCursorPosition(UIParent);
	ToggleDropDownMenu(1, nil, profilesmenu, "UIParent", x / UIParent:GetEffectiveScale() , y / UIParent:GetEffectiveScale())
end
----------------------- MINIMAP END -----------------------------------------------------------------------------------------
